/* za .h fajl, njegov pridruzeni .c fajl sadrzi implementacije 
svih funkcija koje se pojavljuju u .h fajlu */
#include "liste.h"
#include <stdio.h>
#include <stdlib.h>

EL* napraviel(int v){
   EL *novi=NULL;
   /* uzima se heap-a sizeo(EL) bajtova i vraca
     se adresa et memorije
   */
   novi = malloc(sizeof(EL));
   (*novi).vr = v;
   (*novi).sl = NULL;
   return novi;                
}

EL* ubacip(EL *plist, int v){
     EL* novi = napraviel(v);
     if(plist==NULL){
          plist = novi;                
     }else{
           //ako lista nije prazna, komplikovanije      
           /*
           l = NULL
           ubaci 3
           3->NULL
           ubaci 4
           4->3->NULL
           */
           (*novi).sl = plist;
           plist = novi; 
     }
     return plist;
}

/*
 '*' je operator derefernciranja - za datu adresu, vraca
 vrednost koja je zapisana na toj adresi
 '&' - za konkretnu promenljivu vraca adresu na kojoj je
 ona zapisana
 
 int a = 4;
 int *pa = &a; 
 int b = *pa;
*/
void ispisil(EL *plist){
     while(plist!=NULL){
           printf("%d\t",(*plist).vr); 
           plist = (*plist).sl; // prelazak na sledeci element liste                   
     }     
}

/* 1->2->3->4->NULL
brisanje:
1) u pomocnu promenljivu upisemo pokazivac na sledeci
2) obrisemo aktivni
3) novi aktivni je pomocna promenljiva
*/

void obrisi(EL *plist){
     EL *pom;
     while(plist!=NULL){
             pom = (*plist).sl;
             printf("Brisem el. %d\n",(*plist).vr);
             free(plist); /* funkciji free saljemo
             lokaciju (a ne vrednost) onoga sto treba da 
             obrisemo. Free radi samo za promenljive
             koje su kreirane din. alokacijom */
             plist = pom;                 
     }     
} 

EL* ucitajp(){
 EL *plista = NULL;
  int b;
  
  while(1){
           scanf("%d", &b);
           if(b==-1)
                    break;
           plista = ubacip(plista,b);         
  }  
  return plista; 
}
